package blusunrize.immersiveengineering.client.gui;

import blusunrize.immersiveengineering.ImmersiveEngineering;
import blusunrize.immersiveengineering.api.Lib;
import blusunrize.immersiveengineering.client.ClientUtils;
import blusunrize.immersiveengineering.common.blocks.wooden.TileEntitySorter;
import blusunrize.immersiveengineering.common.gui.ContainerSorter;
import blusunrize.immersiveengineering.common.util.network.MessageTileSync;
import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.GuiButton;
import net.minecraft.client.gui.inventory.GuiContainer;
import net.minecraft.client.renderer.OpenGlHelper;
import net.minecraft.client.renderer.RenderHelper;
import net.minecraft.client.resources.I18n;
import net.minecraft.entity.player.InventoryPlayer;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.text.TextFormatting;
import net.minecraftforge.fml.common.FMLCommonHandler;
import net.minecraftforge.fml.relauncher.Side;
import org.lwjgl.opengl.GL11;

import java.util.ArrayList;

public class GuiSorter extends GuiContainer
{
	TileEntitySorter tile;
	public GuiSorter(InventoryPlayer inventoryPlayer, TileEntitySorter tile)
	{
		super(new ContainerSorter(inventoryPlayer, tile));
		this.tile=tile;
		this.field_147000_g = 244;
	}

	@Override
	public void func_73863_a(int mx, int my, float partial)
	{
		super.func_73863_a(mx, my, partial);
		for(GuiButton button : this.field_146292_n)
		{
			if(button instanceof ButtonSorter)
				if(mx>button.field_146128_h&&mx<button.field_146128_h+18 && my>button.field_146129_i&&my<button.field_146129_i+18)
				{
					ArrayList<String> tooltip = new ArrayList<String>();
					int type = ((ButtonSorter)button).type;
					String[] split = I18n.func_135052_a(Lib.DESC_INFO + "filter." + (type == 0 ? "oreDict" : type == 1 ? "nbt" : "fuzzy")).split("<br>");
					for(int i=0; i<split.length; i++)
						tooltip.add((i==0? TextFormatting.WHITE: TextFormatting.GRAY)+split[i]);
					ClientUtils.drawHoveringText(tooltip, mx, my, field_146289_q, field_147003_i+field_146999_f,-1);
					RenderHelper.func_74520_c();
				}
		}
	}


	@Override
	protected void func_146976_a(float f, int mx, int my)
	{
		GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
		ClientUtils.bindTexture("immersiveengineering:textures/gui/sorter.png");
		this.func_73729_b(field_147003_i,field_147009_r, 0, 0, field_146999_f, field_147000_g);
		for(int side=0; side<6; side++)
		{
			int x = field_147003_i+ 30+ (side/2)*58;
			int y = field_147009_r+ 44+ (side%2)*76;
			String s = I18n.func_135052_a("desc.immersiveengineering.info.blockSide."+EnumFacing.func_82600_a(side).toString()).substring(0, 1);
			GL11.glEnable(3042);
			ClientUtils.font().func_175065_a(s, x-(ClientUtils.font().func_78256_a(s)/2), y, 0xaacccccc, true);
		}
		ClientUtils.bindTexture("immersiveengineering:textures/gui/sorter.png");
	}

	@Override
	public void func_73866_w_()
	{
		super.func_73866_w_();
		this.field_146292_n.clear();
		for(int side=0; side<6; side++)
			for(int i=0; i<3; i++)
			{
				int x = field_147003_i+3+ (side/2)*58 +i*18;
				int y = field_147009_r+3+ (side%2)*76;
				ButtonSorter b = new ButtonSorter(side*3+i, x,y, i);
				b.active = i==0?this.tile.doOredict(side): i==1?this.tile.doNBT(side): this.tile.doFuzzy(side);
				this.field_146292_n.add(b);
			}
	}

	@Override
	protected void func_146284_a(GuiButton button)
	{
		if(button instanceof ButtonSorter && FMLCommonHandler.instance().getEffectiveSide()==Side.CLIENT)
		{
			int side = button.field_146127_k/3;
			int bit = button.field_146127_k%3;
			int mask = (1<<bit);
			this.tile.sideFilter[side] = this.tile.sideFilter[side]^mask;

			NBTTagCompound tag = new NBTTagCompound();
			tag.func_74783_a("sideConfig", this.tile.sideFilter);
			ImmersiveEngineering.packetHandler.sendToServer(new MessageTileSync(tile, tag));
			this.func_73866_w_();
		}
	}

	public static class ButtonSorter extends GuiButton
	{
		int type; 
		boolean active = false;
		public ButtonSorter(int id, int x, int y, int type)
		{
			super(id, x, y, 18,18, "");
			this.type = type;
		}

		@Override
		public void func_146112_a(Minecraft mc, int mx, int my)
		{
			if (this.field_146125_m)
			{
				GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
				this.field_146123_n = mx >= this.field_146128_h && my >= this.field_146129_i && mx < this.field_146128_h + this.field_146120_f && my < this.field_146129_i + this.field_146121_g;
				GL11.glEnable(GL11.GL_BLEND);
				OpenGlHelper.func_148821_a(770, 771, 1, 0);
				GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
				this.func_73729_b(this.field_146128_h, this.field_146129_i, 176+type*18,(active?3:21), this.field_146120_f, this.field_146121_g);
				this.func_146119_b(mc, mx, my);
			}
		}
	}
}
